> ## Documentation Index
> Fetch the complete documentation index at: https://docs.seam.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a Thermostat Daily Program

> Creates a new thermostat daily program. A daily program consists of a set of periods, where each period includes a start time and the key of a configured climate preset. Once you have defined a daily program, you can assign it to one or more days within a weekly program.



## OpenAPI

````yaml /openapi.json post /thermostats/daily_programs/create
openapi: 3.0.0
info:
  title: Seam Connect
  version: 1.0.0
servers:
  - url: https://connect.getseam.com
security: []
tags:
  - description: access_codes
    name: /access_codes
  - description: acs
    name: /acs
  - description: action_attempts
    name: /action_attempts
  - description: client_sessions
    name: /client_sessions
  - description: connected_accounts
    name: /connected_accounts
  - description: connect_webviews
    name: /connect_webviews
  - description: devices
    name: /devices
  - description: events
    name: /events
  - description: health
    name: /health
  - description: locks
    name: /locks
  - description: networks
    name: /networks
  - description: noise_sensors
    name: /noise_sensors
  - description: phones
    name: /phones
  - description: thermostats
    name: /thermostats
  - description: user_identities
    name: /user_identities
  - description: webhooks
    name: /webhooks
  - description: workspaces
    name: /workspaces
paths:
  /thermostats/daily_programs/create:
    post:
      tags:
        - /thermostats
      summary: Create a Thermostat Daily Program
      description: >-
        Creates a new thermostat daily program. A daily program consists of a
        set of periods, where each period includes a start time and the key of a
        configured climate preset. Once you have defined a daily program, you
        can assign it to one or more days within a weekly program.
      operationId: thermostatsDailyProgramsCreatePost
      requestBody:
        content:
          application/json:
            schema:
              properties:
                device_id:
                  description: >-
                    ID of the thermostat device for which you want to create a
                    daily program.
                  format: uuid
                  type: string
                name:
                  description: Name of the thermostat daily program.
                  type: string
                periods:
                  description: Array of thermostat daily program periods.
                  items:
                    description: >-
                      Period for a thermostat daily program. Consists of a
                      starts at time and the key that identifies the configured
                      climate preset to apply at the starting time.
                    properties:
                      climate_preset_key:
                        description: >-
                          Key of the [climate
                          preset](https://docs.seam.co/capability-guides/thermostats/creating-and-managing-climate-presets)
                          to activate at the `starts_at_time`.
                        type: string
                      starts_at_time:
                        description: >-
                          Time at which the thermostat daily program period
                          starts, in [ISO
                          8601](https://www.iso.org/iso-8601-date-and-time-format.html)
                          format.
                        pattern: ^([01]\d|2[0-3]):([0-5]\d):([0-5]\d)$
                        type: string
                    required:
                      - starts_at_time
                      - climate_preset_key
                    type: object
                  type: array
              required:
                - device_id
                - name
                - periods
              type: object
      responses:
        '200':
          content:
            application/json:
              schema:
                properties:
                  ok:
                    type: boolean
                  thermostat_daily_program:
                    $ref: '#/components/schemas/thermostat_daily_program'
                required:
                  - thermostat_daily_program
                  - ok
                type: object
          description: OK
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
      security:
        - client_session: []
        - pat_with_workspace: []
        - console_session_with_workspace: []
        - api_key: []
      x-codeSamples:
        - lang: javascript
          label: Seam SDK
          source: |-
            await seam.thermostats.dailyPrograms.create({
              device_id: "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
              name: "Weekday Program",
              periods: [
                { starts_at_time: "07:00:00", climate_preset_key: "Home" },
                { starts_at_time: "09:00:00", climate_preset_key: "Away" },
                { starts_at_time: "16:00:00", climate_preset_key: "Home" },
                { starts_at_time: "22:30:00", climate_preset_key: "Sleep" },
              ],
            });

            /*
            {
              "created_at": "2025-06-14T16:54:17.946642Z",
              "device_id": "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
              "name": "Weekday Program",
              "periods": [
                {
                  "starts_at_time": "07:00:00",
                  "climate_preset_key": "Home"
                },
                {
                  "starts_at_time": "09:00:00",
                  "climate_preset_key": "Away"
                },
                {
                  "starts_at_time": "16:00:00",
                  "climate_preset_key": "Home"
                },
                {
                  "starts_at_time": "22:30:00",
                  "climate_preset_key": "Sleep"
                }
              ],
              "thermostat_daily_program_id": "ab8ef74c-c7cd-4100-aa32-0ef960c0080d",
              "workspace_id": "8da8d923-e55b-45cd-84a3-6c96b3d3d454"
            }
            */
        - lang: bash
          label: cURL
          source: >-
            curl --include --request POST
            "https://connect.getseam.com/thermostats/daily_programs/create" \
              --header "Authorization: Bearer $SEAM_API_KEY" \
              --json @- <<EOF
            {
              "device_id": "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
              "name": "Weekday Program",
              "periods": [
                {
                  "starts_at_time": "07:00:00",
                  "climate_preset_key": "Home"
                },
                {
                  "starts_at_time": "09:00:00",
                  "climate_preset_key": "Away"
                },
                {
                  "starts_at_time": "16:00:00",
                  "climate_preset_key": "Home"
                },
                {
                  "starts_at_time": "22:30:00",
                  "climate_preset_key": "Sleep"
                }
              ]
            }

            EOF


            # Response:

            # {

            #   "thermostat_daily_program": {

            #     "created_at": "2025-06-14T16:54:17.946642Z",

            #     "device_id": "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",

            #     "name": "Weekday Program",

            #     "periods": [

            #       {

            #         "starts_at_time": "07:00:00",

            #         "climate_preset_key": "Home"

            #       },

            #       {

            #         "starts_at_time": "09:00:00",

            #         "climate_preset_key": "Away"

            #       },

            #       {

            #         "starts_at_time": "16:00:00",

            #         "climate_preset_key": "Home"

            #       },

            #       {

            #         "starts_at_time": "22:30:00",

            #         "climate_preset_key": "Sleep"

            #       }

            #     ],

            #     "thermostat_daily_program_id":
            "ab8ef74c-c7cd-4100-aa32-0ef960c0080d",

            #     "workspace_id": "8da8d923-e55b-45cd-84a3-6c96b3d3d454"

            #   }

            # }
        - lang: python
          label: Seam SDK
          source: |-
            seam.thermostats.daily_programs.create(
                device_id="cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
                name="Weekday Program",
                periods=[
                    {"starts_at_time": "07:00:00", "climate_preset_key": "Home"},
                    {"starts_at_time": "09:00:00", "climate_preset_key": "Away"},
                    {"starts_at_time": "16:00:00", "climate_preset_key": "Home"},
                    {"starts_at_time": "22:30:00", "climate_preset_key": "Sleep"},
                ],
            )

            # ThermostatDailyProgram(
                created_at="2025-06-14T16:54:17.946642Z",
                device_id="cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
                name="Weekday Program",
                periods=[
                    {"starts_at_time": "07:00:00", "climate_preset_key": "Home"},
                    {"starts_at_time": "09:00:00", "climate_preset_key": "Away"},
                    {"starts_at_time": "16:00:00", "climate_preset_key": "Home"},
                    {"starts_at_time": "22:30:00", "climate_preset_key": "Sleep"},
                ],
                thermostat_daily_program_id="ab8ef74c-c7cd-4100-aa32-0ef960c0080d",
                workspace_id="8da8d923-e55b-45cd-84a3-6c96b3d3d454",
            )
        - lang: ruby
          label: Seam SDK
          source: |-
            seam.thermostats.daily_programs.create(
              device_id: "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
              name: "Weekday Program",
              periods: [
                { starts_at_time: "07:00:00", climate_preset_key: "Home" },
                { starts_at_time: "09:00:00", climate_preset_key: "Away" },
                { starts_at_time: "16:00:00", climate_preset_key: "Home" },
                { starts_at_time: "22:30:00", climate_preset_key: "Sleep" },
              ],
            )

            # => {
              "created_at" => "2025-06-14T16:54:17.946642Z",
              "device_id" => "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
              "name" => "Weekday Program",
              "periods" => [
                { starts_at_time: "07:00:00", climate_preset_key: "Home" },
                { starts_at_time: "09:00:00", climate_preset_key: "Away" },
                { starts_at_time: "16:00:00", climate_preset_key: "Home" },
                { starts_at_time: "22:30:00", climate_preset_key: "Sleep" },
              ],
              "thermostat_daily_program_id" => "ab8ef74c-c7cd-4100-aa32-0ef960c0080d",
              "workspace_id" => "8da8d923-e55b-45cd-84a3-6c96b3d3d454",
            }
        - lang: php
          label: Seam SDK
          source: |-
            $seam->thermostats->daily_programs->create(
                device_id: "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
                name: "Weekday Program",
                periods: [
                    ["starts_at_time" => "07:00:00", "climate_preset_key" => "Home"],
                    ["starts_at_time" => "09:00:00", "climate_preset_key" => "Away"],
                    ["starts_at_time" => "16:00:00", "climate_preset_key" => "Home"],
                    ["starts_at_time" => "22:30:00", "climate_preset_key" => "Sleep"],
                ],
            );

            // [
                "created_at" => "2025-06-14T16:54:17.946642Z",
                "device_id" => "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",
                "name" => "Weekday Program",
                "periods" => [
                    ["starts_at_time" => "07:00:00", "climate_preset_key" => "Home"],
                    ["starts_at_time" => "09:00:00", "climate_preset_key" => "Away"],
                    ["starts_at_time" => "16:00:00", "climate_preset_key" => "Home"],
                    ["starts_at_time" => "22:30:00", "climate_preset_key" => "Sleep"],
                ],
                "thermostat_daily_program_id" => "ab8ef74c-c7cd-4100-aa32-0ef960c0080d",
                "workspace_id" => "8da8d923-e55b-45cd-84a3-6c96b3d3d454",
            ];
        - lang: bash
          label: Seam CLI
          source: >-
            seam thermostats daily-programs create --device_id
            "cc2d0fb9-1f5f-410f-80f1-a64b699de82a" --name "Weekday Program"
            --periods
            [{"starts_at_time":"07:00:00","climate_preset_key":"Home"},{"starts_at_time":"09:00:00","climate_preset_key":"Away"},{"starts_at_time":"16:00:00","climate_preset_key":"Home"},{"starts_at_time":"22:30:00","climate_preset_key":"Sleep"}]


            # {

            #   "created_at": "2025-06-14T16:54:17.946642Z",

            #   "device_id": "cc2d0fb9-1f5f-410f-80f1-a64b699de82a",

            #   "name": "Weekday Program",

            #   "periods": [

            #     {

            #       "starts_at_time": "07:00:00",

            #       "climate_preset_key": "Home"

            #     },

            #     {

            #       "starts_at_time": "09:00:00",

            #       "climate_preset_key": "Away"

            #     },

            #     {

            #       "starts_at_time": "16:00:00",

            #       "climate_preset_key": "Home"

            #     },

            #     {

            #       "starts_at_time": "22:30:00",

            #       "climate_preset_key": "Sleep"

            #     }

            #   ],

            #   "thermostat_daily_program_id":
            "ab8ef74c-c7cd-4100-aa32-0ef960c0080d",

            #   "workspace_id": "8da8d923-e55b-45cd-84a3-6c96b3d3d454"

            # }
components:
  schemas:
    thermostat_daily_program:
      description: >-
        Represents a thermostat daily program, consisting of a set of periods,
        each of which has a starting time and the key that identifies the
        climate preset to apply at the starting time.
      properties:
        created_at:
          description: Date and time at which the thermostat daily program was created.
          format: date-time
          type: string
        device_id:
          description: >-
            ID of the thermostat device on which the thermostat daily program is
            configured.
          format: uuid
          type: string
        name:
          description: User-friendly name to identify the thermostat daily program.
          nullable: true
          type: string
        periods:
          description: Array of thermostat daily program periods.
          items:
            description: >-
              Period for a thermostat daily program. Consists of a starts at
              time and the key that identifies the configured climate preset to
              apply at the starting time.
            properties:
              climate_preset_key:
                description: >-
                  Key of the [climate
                  preset](https://docs.seam.co/capability-guides/thermostats/creating-and-managing-climate-presets)
                  to activate at the `starts_at_time`.
                type: string
              starts_at_time:
                description: >-
                  Time at which the thermostat daily program period starts, in
                  [ISO
                  8601](https://www.iso.org/iso-8601-date-and-time-format.html)
                  format.
                pattern: ^([01]\d|2[0-3]):([0-5]\d):([0-5]\d)$
                type: string
            required:
              - starts_at_time
              - climate_preset_key
            type: object
          type: array
        thermostat_daily_program_id:
          description: ID of the thermostat daily program.
          format: uuid
          type: string
        workspace_id:
          description: >-
            ID of the [workspace](https://docs.seam.co/core-concepts/workspaces)
            that contains the thermostat daily program.
          format: uuid
          type: string
      required:
        - thermostat_daily_program_id
        - device_id
        - name
        - periods
        - workspace_id
        - created_at
      type: object
      x-route-path: /thermostats/daily_programs
  securitySchemes:
    client_session:
      bearerFormat: Client Session Token
      scheme: bearer
      type: http
    pat_with_workspace:
      bearerFormat: API Token
      scheme: bearer
      type: http
    console_session_with_workspace:
      bearerFormat: Console Session Token
      scheme: bearer
      type: http
    api_key:
      bearerFormat: API Key
      scheme: bearer
      type: http

````